/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 10 juin 2003 by jerome OFFROY (offroy@lifl.fr)
 *
 */

package org.omg.lifl.eclipse.plugin.project.utils.SWT;

/**
 * This class represents a configuration element for the OpenCCM build.properties config file
 *
 * @author offroy@lifl.fr
 *
 * @version 0.1
 */
public class SetterGroupPreference {

    private String _GroupLabel;
    private String _Name;
    private String _Label;
    private boolean enable = true;

    /**
     * @param groupLabel the name of the SWT Group
     * @param label the label for the SWT configuration element
     * @param name the value for the configuration element
     */
    public SetterGroupPreference(String groupLabel, String label, String name) {
        set_GroupLabel(groupLabel);
        set_Label(label);
        set_Name(name);
    }

    /**
     * @return a String which is the label of the SWT group 
     */
    public String get_GroupLabel() {
        return _GroupLabel;
    }

    /**
     * @return a String which is the label for the element to configure 
     */
    public String get_Label() {
        return _Label;
    }

    /**
     * @return a String which is the name for the element to configure
     */
    public String get_Name() {
        return _Name;
    }

    /**
     * @param string is the name for the SWT Group
     */
    public void set_GroupLabel(String string) {
        _GroupLabel = string;
    }

    /**
     * @param string is the name for the label of the element to configure
     */
    public void set_Label(String string) {
        _Label = string;
    }

    /**
     * @param string is the name for the element to configure
     */
    public void set_Name(String string) {
        _Name = string;
    }

    /**
     * @return  true if the configuration element is enable
     *          flase if the configuration element is not enable
     */
    public boolean isEnable() {
        return enable;
    }

    /**
     * @param b   
     */
    public void setEnable(boolean b) {
        enable = b;
    }

}
