#!/bin/sh
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2002 USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Romain Rouvoy.
# Contributor(s): ____________________________________________________.
#
# ====================================================================
#
#  Starting Ant Compilation Process
#
# ====================================================================

if [ -z "$JAVA_HOME" ] ; then
  JAVAC=`which java`
  if [ -z "$JAVAC" ] ; then
    echo "Cannot find JAVA. Please set your PATH."
    exit 1
  fi
  JAVA_BIN=`dirname $JAVAC`
  JAVA_HOME=$JAVA_BIN/..
  export JAVA_HOME
else
  JAVA_BIN=$JAVA_HOME/bin
fi
 
#
# Determinate what the path separator is:
# - On Unix systems, it is ':'
# - On CygWin systems, it is ';'
#
PS=':'
if [ $OSTYPE = "cygwin32" ] || [ $OSTYPE = "cygwin" ] ; then
    PS=';'
fi
 
#
# Add the path to the 'java' command in the $PATH variable because
# the OpenCCM Ant build.xml could start the 'javacc' task that
# requires that the 'java' command was accessible through the $PATH.
#
PATH=$JAVA_BIN:$PATH
export PATH


CLASSPATH=@CLASSPATH@

#$JAVA_BIN/java -cp $CLASSPATH -Dant.home=@ANT_HOME@ org.apache.tools.ant.Main "$@" -buildfile build.xml
@JAVA@ -cp $CLASSPATH -Dant.home=@ANT_HOME@ org.apache.tools.ant.Main "$@" -quiet -buildfile build.xml
