/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.pss.demo1;


public class FormImpl 
     extends FormPOA
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The basic session */
    org.omg.CosPersistentState.Session _session;

    /** The Person storage home */
    SH_Person _person_home;

    /** The Address storage home */
    SH_Address _address_home;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     * Default Constructor
     */
    public FormImpl(org.omg.CosPersistentState.Session session)
    {
        _session = session;
        try
        {
            _person_home = (SH_Person)
                                _session.find_storage_home("PSDL:openccm.objectweb.org/pss/demo1/SH_Person:1.0");
        }catch(org.omg.CosPersistentState.NotFound e){
            e.printStackTrace();
        }
        try
        {
            _address_home = (SH_Address)
                                _session.find_storage_home("PSDL:openccm.objectweb.org/pss/demo1/SH_Address:1.0");
        }catch(org.omg.CosPersistentState.NotFound e){
            e.printStackTrace();
        }
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Operation createPerson
     */
    public void
    createPerson( String first_name,
                  String last_name,
                  int age,
                  String address_line1,
                  String address_line2,
                  String address_city,
                  String address_zip)
    {
        Address a = null;
        Person p = null;

        try{
            a = _address_home._create( address_line1, address_line2, address_city, address_zip );

            p = _person_home.my_create( first_name, last_name );
        }catch(Exception e){
            e.printStackTrace();
        }

        try{
        javax.jdo.PersistenceManager pm = null;

        // Get the persistent manager
        pm = ((org.objectweb.openccm.services.pss.jdo.api.CatalogBase) p.get_storage_home().
                get_catalog()).get_persistence_manager();

        // Remove the storage type
        javax.jdo.Transaction t = pm.currentTransaction();
        t.begin();
            p.age(age);
            p.adress( a.get_pid() );
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    /**
     * Operation removePerson
     */
    public void removePerson( java.lang.String first_name,
                              java.lang.String last_name )
    {
        try
        {
            Person p = _person_home.find_by_mykey( first_name, last_name );

            p.destroy_object();
        }
        catch ( org.omg.CosPersistentState.NotFound ex )
        {
            System.out.println( "This person was not found..." );
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    /**
     * Operation showPerson
     */
    public void showPerson( java.lang.String first_name,
                            java.lang.String last_name )
    {
        try
        {
            Person p = _person_home.find_by_mykey( first_name, last_name );

            if (p != null)
                p.print();
            else
                System.out.println( "This person was not found..." );
        }
        catch ( org.omg.CosPersistentState.NotFound ex )
        {
            System.out.println( "This person was not found..." );
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
}
