/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.Deployment;

import java.awt.Component;
//import javax.swing.JOptionPane;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;

import org.objectweb.openccm.browser.menu.FileChooserBox;
import org.objectweb.openccm.browser.menu.OpenCCMBrowserConstants;
import org.objectweb.util.browser.api.ExtendedActionEvent;
import org.objectweb.util.browser.api.ExtendedActionListener;
import org.omg.Components.Deployment.ComponentServer;

/**
 * Creates a new container from a ComponentServer.
 * You have to specify the config of the container.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class CreateContainer implements ExtendedActionListener {

    /**
     * Returns a String which contains all the file contents.
     */
    protected String fileToString(File f) throws Exception {
        StringBuffer bf = new StringBuffer();
        BufferedReader in = new BufferedReader(new FileReader(f));
        String line = "";
        while (line != null) {
            bf.append(line);
            line = in.readLine();
        }
        return bf.toString();
    }

    public void actionPerformed(ExtendedActionEvent e) throws Exception {
       ComponentServer cs = (ComponentServer) e.getCurrentValue();

//        Object[] options = { "Create", "Cancel" };
//        FileChooserBox fcb = new FileChooserBox("Config File : ", 0);
//	  int result =
//            JOptionPane.showOptionDialog((Component) e.getActionEvent().getSource(), fcb, "Create a container", JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE, null, options, options[0]);
//        if (result == 0) {

//            File f = fcb.getFile();
//            if (f != null && f.exists()) {
//                org.omg.Components.ConfigValue[] config = new org.omg.Components.ConfigValue[1];
        org.omg.Components.ConfigValue[] config = new org.omg.Components.ConfigValue[0];
//                config[0] = new org.objectweb.ccm.Components.ConfigValueImpl();
//                config[0].name = "container_script";
//                org.omg.CORBA.TypeCode string_tc = org.objectweb.ccm.CORBA.TheORB.getORB().get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
//                org.omg.CORBA.Any value = org.objectweb.ccm.CORBA.TheDynamicAnyFactory.getFactory().create_dyn_any_from_type_code(string_tc).to_any();
//                value.insert_string(fileToString(f));
//                config[0].value = value;
        cs.create_container(config);
//            } else {
//                throw new Exception("You must select a config file !");
//            }
//        }
    }

}
