/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.menu;

/** The application's imports*/
import org.objectweb.util.browser.gui.core.DynamicTree;

/** The java API's imports */
import javax.swing.ImageIcon;

/**
 * This class represents the leave action
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class RefreshAction extends AbstractMenuAction {

    public RefreshAction(String nom, ImageIcon image, String desc, Integer mnemonic, DynamicTree tree) {
        super(nom, image, desc, mnemonic, tree);
    }

    public void actionPerformed(java.awt.event.ActionEvent ae) {
        tree_.refreshAll();
    }

}
