#include "StdAfx.h"
#include "common.h"
#include <windows.h> 
#include <winperf.h>
#include <stdlib.h> 
#include <tlhelp32.h>
// 
// manafest constants 
// 
#define INITIAL_SIZE        51200 
#define EXTEND_SIZE         25600 
#define REGKEY_PERF         "software\\microsoft\\windows nt\\currentversion\\perflib" 
#define REGSUBKEY_COUNTERS  "Counters" 
#define PROCESS_COUNTER     "process" 
#define PROCESSID_COUNTER   "id process" 
#define UNKNOWN_TASK        "unknown"

int test(int t){return 90;}

// 
// Function pointer types for accessing Toolhelp32 functions dynamically. 
// By dynamically accessing these functions, we can do so only on Windows 
// 95 and still run on Windows NT, which does not have these functions. 
// 
typedef BOOL (WINAPI *PROCESSWALK)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe); 
typedef HANDLE (WINAPI *CREATESNAPSHOT)(DWORD dwFlags, DWORD th32ProcessID); 

DWORD 
GetTaskList95( 
    PTASK_LIST  pTask, 
    DWORD       dwNumTasks 
    )
{ 
   CREATESNAPSHOT pCreateToolhelp32Snapshot = NULL; 
   PROCESSWALK    pProcess32First           = NULL; 
   PROCESSWALK    pProcess32Next            = NULL; 

   HANDLE         hKernel        = NULL; 
   HANDLE         hProcessSnap   = NULL; 
   PROCESSENTRY32 pe32           = {0}; 
   DWORD          dwTaskCount    = 0; 


   // Guarantee to the code later on that we'll enum at least one task. 
   if (dwNumTasks == 0) 
      return 0; 

    // Obtain a module handle to KERNEL so that we can get the addresses of 
    // the 32-bit Toolhelp functions we need. 
    hKernel = GetModuleHandle("KERNEL32.DLL"); 

    if (hKernel) 
    { 
        pCreateToolhelp32Snapshot = 
          (CREATESNAPSHOT)GetProcAddress((struct HINSTANCE__ *)hKernel, "CreateToolhelp32Snapshot"); 

        pProcess32First = (PROCESSWALK)GetProcAddress((struct HINSTANCE__ *)hKernel, 
                                                      "Process32First"); 
        pProcess32Next  = (PROCESSWALK)GetProcAddress((struct HINSTANCE__ *)hKernel, 
                                                      "Process32Next"); 
    } 
     
    // make sure we got addresses of all needed Toolhelp functions. 
    if (!(pProcess32First && pProcess32Next && pCreateToolhelp32Snapshot)) 
       return 0; 
        

    // Take a snapshot of all processes currently in the system. 
    hProcessSnap = pCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); 
    if (hProcessSnap == (HANDLE)-1) 
        return 0; 

    // Walk the snapshot of processes and for each process, get information 
    // to display. 
    dwTaskCount = 0; 
    pe32.dwSize = sizeof(PROCESSENTRY32);   // must be filled out before use 
    if (pProcess32First(hProcessSnap, &pe32)) 
    { 
        do 
        { 
            LPSTR pCurChar; 

            // strip path and leave executabe filename splitpath 
            for (pCurChar = (pe32.szExeFile + lstrlen (pe32.szExeFile)); 
                 *pCurChar != '\\' && pCurChar != pe32.szExeFile;  
                 --pCurChar) 

            lstrcpy(pTask -> ProcessName, pCurChar); 
            pTask -> flags = 0; 
            pTask -> dwProcessId = pe32.th32ProcessID; 

            ++dwTaskCount;   // keep track of how many tasks we've got so far 
            ++pTask;         // get to next task info block. 
        } 
        while (dwTaskCount < dwNumTasks && pProcess32Next(hProcessSnap, &pe32)); 
    } 
    else 
        dwTaskCount = 0;    // Couldn't walk the list of processes. 

    // Don't forget to clean up the snapshot object... 
    CloseHandle (hProcessSnap); 

    return dwTaskCount; 
} 


DWORD 
GetTaskListNT( 
    PTASK_LIST  pTask, 
    DWORD       dwNumTasks 
    )
{ 
    DWORD                        rc; 
    HKEY                         hKeyNames; 
    DWORD                        dwType; 
    DWORD                        dwSize; 
    LPBYTE                       buf = NULL; 
    CHAR                         szSubKey[1024]; 
    LANGID                       lid; 
    LPSTR                        p; 
    LPSTR                        p2; 
    PPERF_DATA_BLOCK             pPerf; 
    PPERF_OBJECT_TYPE            pObj; 
    PPERF_INSTANCE_DEFINITION    pInst; 
    PPERF_COUNTER_BLOCK          pCounter; 
    PPERF_COUNTER_DEFINITION     pCounterDef; 
    DWORD                        i; 
    DWORD                        dwProcessIdTitle; 
    DWORD                        dwProcessIdCounter; 
    CHAR                         szProcessName[MAX_PATH]; 
    DWORD                        dwLimit = dwNumTasks - 1; 



    // 
    // Look for the list of counters.  Always use the neutral 
    // English version, regardless of the local language.  We 
    // are looking for some particular keys, and we are always 
    // going to do our looking in English.  We are not going 
    // to show the user the counter names, so there is no need 
    // to go find the corresponding name in the local language. 
    // 
    lid = MAKELANGID( LANG_ENGLISH, SUBLANG_NEUTRAL ); 
    sprintf( szSubKey, "%s\\%03x", REGKEY_PERF, lid ); 
	printf("%s\n",szSubKey);
    rc = RegOpenKeyEx( HKEY_LOCAL_MACHINE, 
                       szSubKey, 
                       0, 
                       KEY_READ, 
                       &hKeyNames 
                     ); 
    if (rc != ERROR_SUCCESS) { 
        goto exit; 
    } 

    // 
    // get the buffer size for the counter names 
    // 
    rc = RegQueryValueEx( hKeyNames, 
                          REGSUBKEY_COUNTERS, 
                          NULL, 
                          &dwType, 
                          NULL, 
                          &dwSize 
                        ); 

    if (rc != ERROR_SUCCESS) { 
        goto exit; 
    } 

    // 
    // allocate the counter names buffer 
    // 
    buf = (LPBYTE) malloc( dwSize ); 
    if (buf == NULL) { 
        goto exit; 
    } 
    memset( buf, 0, dwSize ); 

    // 
    // read the counter names from the registry 
    // 
    rc = RegQueryValueEx( hKeyNames, 
                          REGSUBKEY_COUNTERS, 
                          NULL, 
                          &dwType, 
                          buf, 
                          &dwSize 
                        ); 

    if (rc != ERROR_SUCCESS) { 
        goto exit; 
    } 

    // 
    // now loop thru the counter names looking for the following counters: 
    // 
    //      1.  "Process"           process name 
    //      2.  "ID Process"        process id 
    // 
    // the buffer contains multiple null terminated strings and then 
    // finally null terminated at the end.  the strings are in pairs of 
    // counter number and counter name. 
    // 


    p = (char *)buf; 
    while (*p) { 
        if (p > (char *)buf) { 
            for( p2=p-2; isdigit(*p2); p2--) ; 
            } 
        if (stricmp(p, PROCESS_COUNTER) == 0) { 
            // 
            // look backwards for the counter number 
            // 
            for( p2=p-2; isdigit(*p2); p2--) ; 
            strcpy( szSubKey, p2+1 ); 
        } 
        else 
        if (stricmp(p, PROCESSID_COUNTER) == 0) { 
            // 
            // look backwards for the counter number 
            // 
            for( p2=p-2; isdigit(*p2); p2--) ; 
            dwProcessIdTitle = atol( p2+1 ); 
        } 
        // 
        // next string 
        // 
        p += (strlen(p) + 1); 
    } 

    // 
    // free the counter names buffer 
    // 
    free( buf ); 


    // 
    // allocate the initial buffer for the performance data 
    // 
    dwSize = INITIAL_SIZE; 
    buf = (unsigned char *)malloc( dwSize ); 
    if (buf == NULL) { 
        goto exit; 
    } 
    memset( buf, 0, dwSize ); 


    while (TRUE) { 

        rc = RegQueryValueEx( HKEY_PERFORMANCE_DATA, 
                              szSubKey, 
                              NULL, 
                              &dwType, 
                              buf, 
                              &dwSize 
                            ); 

        pPerf = (PPERF_DATA_BLOCK) buf; 

        // 
        // check for success and valid perf data block signature 
        // 
        if ((rc == ERROR_SUCCESS) && 
            (dwSize > 0) && 
            (pPerf)->Signature[0] == (WCHAR)'P' && 
            (pPerf)->Signature[1] == (WCHAR)'E' && 
            (pPerf)->Signature[2] == (WCHAR)'R' && 
            (pPerf)->Signature[3] == (WCHAR)'F' ) { 
            break; 
        } 

        // 
        // if buffer is not big enough, reallocate and try again 
        // 
        if (rc == ERROR_MORE_DATA) { 
            dwSize += EXTEND_SIZE; 
            buf = (unsigned char *)realloc( buf, dwSize ); 
            memset( buf, 0, dwSize ); 
        } 
        else { 
            goto exit; 
        } 
    } 

    // 
    // set the perf_object_type pointer 
    // 
    pObj = (PPERF_OBJECT_TYPE) ((DWORD)pPerf + pPerf->HeaderLength); 

    // 
    // loop thru the performance counter definition records looking 
    // for the process id counter and then save its offset 
    // 
    pCounterDef = (PPERF_COUNTER_DEFINITION) ((DWORD)pObj + pObj->HeaderLength); 
    for (i=0; i<(DWORD)pObj->NumCounters; i++) { 
        if (pCounterDef->CounterNameTitleIndex == dwProcessIdTitle) { 
            dwProcessIdCounter = pCounterDef->CounterOffset; 
            break; 
        } 
        pCounterDef++; 
    } 

    dwNumTasks = min( dwLimit, (DWORD)pObj->NumInstances ); 

    pInst = (PPERF_INSTANCE_DEFINITION) ((DWORD)pObj + pObj->DefinitionLength); 

    // 
    // loop thru the performance instance data extracting each process name 
    // and process id 
    // 
    for (i=0; i<dwNumTasks; i++) { 
        // 
        // pointer to the process name 
        // 
        p = (LPSTR) ((DWORD)pInst + pInst->NameOffset); 

        // 
        // convert it to ascii 
        // 
        rc = WideCharToMultiByte( CP_ACP, 
                                  0, 
                                  (LPCWSTR)p, 
                                  -1, 
                                  szProcessName, 
                                  sizeof(szProcessName), 
                                  NULL, 
                                  NULL 
                                ); 

        if (!rc) { 
            // 
        // if we cant convert the string then use a default value 
            // 
            strcpy( pTask->ProcessName, UNKNOWN_TASK ); 
        } 

        if (strlen(szProcessName)+4 <= sizeof(pTask->ProcessName)) { 
			
            strcpy( pTask->ProcessName, szProcessName ); 
            strcat( pTask->ProcessName, ".exe" ); 
			//printf("%s\n",pTask->ProcessName);
        } 

        // 
        // get the process id 
        // 
        pCounter = (PPERF_COUNTER_BLOCK) ((DWORD)pInst + pInst->ByteLength); 
        pTask->flags = 0; 
        pTask->dwProcessId = *((LPDWORD) ((DWORD)pCounter + dwProcessIdCounter)); 
        if (pTask->dwProcessId == 0) { 
            pTask->dwProcessId = (DWORD)-2; 
        } 

        // 
        // next process 
        // 
        pTask++; 
        pInst = (PPERF_INSTANCE_DEFINITION) ((DWORD)pCounter + pCounter->ByteLength); 
    } 

exit: 
    if (buf) { 
        free( buf ); 
    } 

    RegCloseKey( hKeyNames ); 
    RegCloseKey( HKEY_PERFORMANCE_DATA ); 

    return dwNumTasks; 
}